/******************************************************************************
;  *       @ͺ                 : MC51F003A4
;  *       @             : 2022.12.19
;  *       @˾/            : SINOMCU.COM-AE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢ Ȩ.
;  *----------------------ժҪ---------------------------------
;  * ʼUART0,UART1                                  
******************************************************************************/

#include "User_Def.h"

/************************************************
;  *    @Function Name       : UART0_Init,baud used timer1
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void UART0_Init_LINSlave(uint16_t uart_baud) {
  SET_UART0EN();                       /*ʹUART0 */
  /*default UART baud used Timer1*/
  Uart0_Mode_Set(UART_MODE_01);        /*ʽ1,8bit*/
  Uart0_REN_set();                     /**/
  Timer1_Mode_Set(TIMER1_MODE_8BIT_RELOAD);

  TL1 =  (256 - FSYS_CLOCK/16/uart_baud);
  TH1 =TL1;    
  Timer1_En();
  SET_SSTAT0();                        /*SCON Bit7 FE */
  UART0_INTR_En();                     /*UART0ж*/
}

/************************************************
;  *    @Function Name       : UART1_Init,baud used timer2
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void UART1_Init(uint16_t uart_baud) {
  uint16_t baud_rate_cacl=0; 
  SET_UART1EN();                       /*ʹUART1 */

  Uart1_Mode_Set(UART_MODE_01);        /*ʽ1,8bit */ 
  Uart1_REN_set();                     /* */
  Uart1_Sel_T2();                      /*UART baud used Timer2*/

  T2CON1 |= DEF_SET_BIT0;              /*ʹT2 */    
  T2_Pre_Scale(T2_PRE_SCALE_1);        /*Ƶ*/
  baud_rate_cacl =  (65536 - FSYS_CLOCK/16/uart_baud);    

  RCAPL2=(uint8_t)(baud_rate_cacl);
  RCAPH2=(uint8_t)(baud_rate_cacl >>8);
  TL2=RCAPL2;
  TH2=RCAPH2;
  T2_Baud_En();                        /*Timer2 16bit reload baud*/

  Timer2_En();   
  //UART1_INTR_En();                   /*UART1ж*/
}

/************************************************
;  *    @Function Name       : putchar
;  *    @Description         : ضprintfUART
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
char putchar(char tx_data) {
#if(defined(EN_PRINT_UART) && EN_PRINT_UART) 
  #if(defined(PRINTF_UART0) && PRINTF_UART0)   
  SBUF = tx_data;                      /*дݵUARTݼĴ*/
  while (!Read_Uart0_TI()) { ;}        /*ȴǰݷ*/
  Uart0_TI_clear();
  #else
  SBUF_1 = tx_data;                    /*дݵUARTݼĴ*/
  while (!Read_Uart1_TI()) { ;}        /*ȴǰݷ*/
  Uart1_TI_clear();
  #endif
#endif
  return tx_data;
}

void UART0_ISR(void) interrupt UART0_IRQn {
  SFR_INTERRUPT_BUFF_BIT_UART0= SFRSL0;          /*жϻSFR*/
  if(Read_Uart0_RI()) {
    Uart0_RI_clear();
    UART_RI_Callback();  
  }
  if( Read_Uart0_TI()) {
    Uart0_TI_clear();
  }
  SFRSL0 = SFR_INTERRUPT_BUFF_BIT_UART0;         /*˳жϻԭSFR*/
}

void UART1_ISR(void) interrupt UART1_IRQn {
  SFR_INTERRUPT_BUFF_BIT_UART1 = SFRSL0;         /*жϻSFR*/
  if(Read_Uart1_RI()) {
    Uart1_RI_clear();
  }
  if(Read_Uart1_TI()) {
    Uart1_TI_clear();
  }
  SFRSL0 = SFR_INTERRUPT_BUFF_BIT_UART1;         /*˳жϻԭSFR*/
}
/**************************** end of file *********************************************/
