/******************************************************************************
;  *       @型号                 : MC51F003A4
;  *       @创建日期             : 2022.12.19
;  *       @公司/作者            : SINOMCU.COM-AE
;  *       @晟矽微官网           : http://www.sinomcu.com/
;  *       @版权                 : 2022 晟矽微电 版权所有.
;  *----------------------摘要描述---------------------------------
;  *                                                       
******************************************************************************/

#ifndef UART_H__
#define UART_H__

#include "MC51F003A4_COMMON.h"

#define UART_MODE_POS             0x06
#define UART_MODE_MASK            (0x03 << UART_MODE_POS)
#define UART_MODE_01              (0x01 << UART_MODE_POS)
#define UART_REN_POS              0x04
#define UART_REN_MASK             (0x01 << UART_REN_POS)
#define UART_REN                  (0x01 << UART_REN_POS)
#define UART_TX_POS               0x01
#define UART_TX_MASK              (0x01 << UART_TX_POS)
#define UART_RX_POS               0x00
#define UART_RX_MASK              (0x01 << UART_RX_POS)
#define UART_FE_POS               0x07
#define UART_FE_MASK              (0x01 << UART_FE_POS)

#define Read_Uart0_TI()           ((SCON & UART_TX_MASK)? 1 : 0 )
#define Uart0_TI_clear()          TI =0
#define Read_Uart0_RI()           ((SCON & UART_RX_MASK)? 1 : 0 )
#define Uart0_RI_clear()          RI =0
#define Uart0_REN_set()           SCON |= UART_REN
#define Read_Uart0_FE()           ((SCON & UART_FE_MASK)? 1 : 0 )
#define Uart0_FE_clear()          FE =0
#define UART0_INTR_En()           UART0IE =1
#define Uart0_Mode_Set(mode_num)  {SCON &= ~UART_MODE_MASK;  SCON |= mode_num;}

#define Read_Uart1_TI()           ((SCON_1 & UART_TX_MASK)? 1 : 0 )
#define Uart1_TI_clear()          SCON_1 &= ~DEF_SET_BIT1
#define Read_Uart1_RI()           ((SCON_1 & UART_RX_MASK)? 1 : 0 )
#define Uart1_RI_clear()          SCON_1 &= ~DEF_SET_BIT0
#define Uart1_REN_set()           SCON_1 |= UART_REN
#define UART1_INTR_En()           {IE1 |= UART1_IE_EN;}
#define Uart1_Mode_Set(mode_num)  {SCON_1 &= ~UART_MODE_MASK;  SCON_1 |= mode_num;}

#define UART1_IE_POS              0x03
#define UART1_IE_MASK             (0x01 << UART1_IE_POS)
#define UART1_IE_EN               (0x01 << UART1_IE_POS)
#define UART1_BAUD_SEL_POS        0x03
#define UART1_BAUD_SEL_MASK       (0x03 << UART1_BAUD_SEL_POS)
#define UART1_BAUD_SEL_T2         (0x03 << UART1_BAUD_SEL_POS)
#define Uart1_Sel_T2()            T2CON1 |= UART1_BAUD_SEL_T2

void UART0_Init_LINSlave(uint16_t uart_baud);
void UART1_Init(uint16_t uart_baud);
char putchar(char tx_data);

#endif

/**************************** end of file *********************************************/

